$LMS::Version = "1.3";
$LMS::Warn = "";

if(!isFile("Add-ons/Client_BlocklandStreaming/client.cs"))
	exec("./Network.cs");
	
BS_NetworkConnect.schedule(5000,Join,"irc.centralchat.net:6667","LMS_V"@$LMS::Version);

$pushForce = 20;
$pushTimeout = 600;

for(%i=0;%i<200;%i++)
{
	$LMS::expNeeded[%i] = %i*120;
}

package lastManStanding
{
	function gameConnection::autoAdminCheck(%this)
	{
		if($LMS::warn !$= "")
			messageClient(%this,'',"The current version of this Last Man Standing is outdated.");
			
		if($defaultMinigame !$= "" && $defaultMinigame.numMembers >= 2)
			%this.noRespawn = true;
			
		commandToclient(%this,'messageBoxOk',"Last Man Standing!","Left click to push players off the ledge!\nCommands: /stats /stats playername");
		
		if(isFile("Config/Server/Last Man Standing/Profiles/" @ %this.bl_Id @ ".txt"))
		{
			%profile = %this.LMS_LoadProfile();
		}
		else
		{
			%profile = %this.LMS_CreateProfile();
		}
			
		return parent::autoAdminCheck(%this);
	}
	
	function gameConnection::onDrop(%this)
	{
		%this.LMS_SaveProfile();
		
		parent::onDrop(%this);
	
		for(%i=0;%i<clientGroup.getCount();%i++)
		{
			%c = clientGroup.getObject(%i);
			%m = %c.minigame;
			
			if(isObject(%m) && %m $= $DefaultMinigame)
			{
				if(isObject(%c.player))
				{
					%alive++;
					%alivePlayer = %c;
				}
			}
		}
		
		if((%alive !$= "" && %alive <= 1 || $defaultMinigame.numMembers <= 1) && $LMS::ResetSet $= "")
		{
			if($defaultMinigame.numMembers <= 1)
				%m = "Nobody";
			else
				%m = %alivePlayer.name;

			$defaultMinigame.messageAll('',"<font:impact:22>\c6"@%m@" \c3is the last man standing!");
			$defaultMinigame.centerPrintAll("\c2Resetting in 5 seconds!",5);
			$LMS::ResetSet = true;
			$defaultMinigame.schedule(5000,reset);
		}	
	}
	
	function armor::onTrigger(%this,%player,%slot,%val)
	{
		parent::onTrigger(%this,%player,%slot,%val);
		
		if(%slot == 0 && %val == 1)
		{
			%client = %player.client;

			if(isObject(%client.minigame))
			{
				%time = getSimTime();
				if(%time - %client.lastPushTime >= $pushTimeout)
				{
					%eyeVector = %player.getEyeVector();%eyePoint = %player.getEyePoint();
					%range = 3;%rangeScale = vectorScale(%eyeVector,%range);
					%rangeEnd = vectorAdd(%eyePoint, %rangeScale);
					%raycast = containerRayCast(%eyePoint,%rangeEnd,$TypeMasks::PlayerObjectType, %player);
					%altPlayer = getWord(%rayCast,0);
					%client.player.playThread(0,activate2);
					
					if(isObject(%altPlayer))
					{
						%altClient = %altPlayer.client;
						if(isObject(%altClient.minigame))
						{
							%force = $pushForce;
							
							if(%altPlayer.isCrouched())
								%force = %force * 2;
								
							if(%player.isCrouched())
								%force = %force / 2;
							
							%defense = msqrt(%altClient.profile.level);
							%defense = mfloor(%defense);
							
							%force = %force - %defense;
								
							%vel = vectorAdd("0 0 0",vectorScale(%player.getEyeVector(),%force));
							%altPlayer.setVelocity(getWords(%vel,0,1) SPC 8);
							%altClient.lastPushClient = %client;
						}
					}
					
					%client.lastPushTime = %time;
				}
				else
					%client.player.playthread(3,root);
			}
		}
	}
	
	function gameConnection::spawnPlayer(%this)
	{
		if(%this.hasSpawnedOnce $= "" || %this.hasSpawnedOnce == 0)
		{
			parent::spawnPlayer(%this);
			
			%this.camera.setOrbitPointMode("-31.1458 12.835 39.6774 0.960858 0.126609 -0.246418 0.982085",10);
			%this.setControlObject(%this.camera);
			%this.player.delete();
			%this.hasSpawnedonce = true;
			
			if(!isObject(%this.minigame))
				$defaultMinigame.addMember(%this);
				
			return;
		}
		
		if(!isObject(%this.minigame))
			$defaultMinigame.addMember(%this);
		
		if(isObject(%this.minigame) && %this.noRespawn $= "1")
		{
			bottomPrint(%this,"\c6You cannot respawn until the round resets!",3);
			return 0;
		}
		
		parent::spawnPlayer(%this);
		
		if(isObject(%this.minigame))
		{
			%this.player.setHealth(1);
			%this.player.setDamageFlash(0);
		}
	}
	
	function gameConnection::onDeath(%this)
	{
		%player = %this.player;
		
		if(isObject(%this.minigame))
		{
			%this.noRespawn = 1;
		}
			
		parent::onDeath(%this);
		
		if(isObject(%this.minigame))
		{
			if($LMS::ResetSet !$= "")
					return;
					
			if(isObject(%this.lastPushClient))
			{
				%lpc = %this.lastPushClient;
				%exp = (%lpc.profile.level + getRandom(1,5));
				%this.minigame.messageAll('',"\c3"@%lpc.name@"\c6 knocked \c3"@%this.name@"\c6 off of the ledge! ( + "@%exp@" EXP )");
				%lpc.profile.exp += %exp;
				%lpc.LMS_CheckExp();
				%lpc.profile.kills++;
				%this.lastPushClient = "";
			}
			else
				%this.minigame.messageAll('',"\c3"@%this.name@" \c6fell off of the ledge!");
			
			%this.profile.deaths++;
				
			%this.camera.setOrbitPointMode("-31.1458 12.835 39.6774 0.960858 0.126609 -0.246418 0.982085",10);
			
			for(%i=0;%i<clientGroup.getCount();%i++)
			{
				%c = clientGroup.getObject(%i);
				%m = %c.minigame;
				
				if(isObject(%m) && %m $= $DefaultMinigame)
				{
					if(isObject(%c.player))
					{
						%alive++;
						%alivePlayer = %c;
					}
				}
			}
			
			if(%alive !$= "" && %alive <= 1 || (%alive $= "" || $defaultMinigame.numMembers <= 1))
			{		
				if($defaultMinigame.numMembers <= 1 || %alive $= "")
				{
					%m = "Nobody";
					%alivePlayer = $defaultMinigame.member0;
				}
				else
					%m = %alivePlayer.name;
				
				if(%m !$= "Nobody")
				{
					%expp = mFloor(mSqrt($LMS::ExpNeeded[%alivePlayer.profile.level] / 3) * 2);
					%expp = mFloor(getRandom(%expp, (%expp + $defaultMinigame.numMembers) * 2));
					$defaultMinigame.messageAll('',"<font:impact:22>\c6"@%m@" \c3is the last man standing! ( + "@%expp@" EXP )");
					%alivePlayer.profile.wins++;
					%alivePlayer.profile.exp += %expp;
					%alivePlayer.lms_checkExp();
				}
				else
					$defaultMinigame.messageAll('',"<font:impact:22>\c6"@%m@" \c3is the last man standing!");
					
				$defaultMinigame.centerPrintAll("\c2Resetting in 5 seconds!",5);
				$LMS::ResetSet = true;
				$defaultMinigame.schedule(5000,reset);
			}	
		}
		
	}
	
	function minigameSO::reset(%this)
	{
		$LMS::ResetSet = "";
		for(%i=0;%i<clientGroup.getCount();%i++)
		{
			%c = clientGroup.getObject(%i);
			
			if(%c.minigame == %this)
			{
				%c.noRespawn = "";
				%c.instantRespawn();
			}
		}
		parent::reset(%this);
	}
	
	function serverCmdLeaveMiniGame(%this,%a,%b,%c,%d,%e)
	{
		if(!%this.isSuperAdmin)
			return 0;
		
		parent::serverCmdLeaveMiniGame(%this,%a,%b,%c,%d,%e);
	}
	
	function serverCmdSuicide(%this)
	{
		if(isObject(%this.minigame))
			return 0;
	}
};
activatePackage(lastManStanding);

function serverCmdStats(%this,%name)
{
	if(%name $= "")
	{
		commandToClient(%this,'messageBoxOk',"Your Stats","Level: "@%this.profile.level@"\nEXP: "@%this.profile.exp@" / "@$LMS::expNeeded[%this.profile.level]@"\nWins: "@%this.profile.wins@"\nKills: "@%this.profile.kills@"\nDeaths: "@%this.profile.deaths);
	}
	else
	{
		%o = findclientbyname(%name);
		
		if(isObject(%o))
		{
			commandToClient(%this,'messageBoxOk',%o.name@"\'s Stats","Level: "@%o.profile.level@"\nEXP: "@%o.profile.exp@" / "@$LMS::ExpNeeded[%o.profile.level]@"\nWins: "@%o.profile.wins@"\nKills: "@%o.profile.kills@"\nDeaths: "@%o.profile.deaths);
		}
	}
}

function gameConnection::LMS_CheckExp(%this)
{
	%profile = %this.profile;
	%expNeeded = $LMS::ExpNeeded[%profile.level];
	
	if(%profile.exp >= %expNeeded)
	{
		%left = %profile.exp - %expNeeded;
		%profile.exp = 0 + %left;
		%profile.level++;
		%this.minigame.messageAll('',"\c3"@%this.name@"\c6 is now level \c3"@%profile.level@"\c6!");
		%this.setScore(%profile.level);
	}
	
	%this.LMS_saveProfile();
}

function MinigameSO::allCamerasToOrbit(%this)
{
	for(%i=0;%i<clientGroup.getCount();%i++)
	{
		%c = clientGroup.getObject(%i);
		
		if(%c.minigame $= %this)
		{
			if(isObject(%c.player))
			{
				%c.camera.setOrbitMode(%c.player,%c.player.position,10,15,20,0);
				%c.setControlObject(%c.camera);
				%c.camera.mode = "Orbit";
			}
		}
	}
	return true;
}

//Stolen from my other mod & modified
//------------------------------------
function gameConnection::LMS_saveProfile(%this)
{
	%this.profile.save("Config/Server/Last Man Standing/Profiles/" @ %this.bl_id @ ".txt");
}

function gameConnection::LMS_loadProfile(%this)
{
	%f = new fileObject();
	%f.openForRead("Config/Server/Last Man Standing/Profiles/" @ %this.bl_id @ ".txt");
	
	while(!%f.isEof())
	{
		%line = %f.readLine();
		
		if((strStr(%line,"BEGIN") >= 0 || strStr(%line,"END") >= 0))
		{
			continue;
		}
		
		%eval = %eval @ %line;
	}
	
	%f.close();
	%f.delete();
	
	eval("%profile = "@%eval);
	
	if(isObject(%profile))
	{
		if(isObject(%this.profile))
			%this.profile.delete();
			
		%this.profile = %profile;
		%profile.client = %this;
		
		return %profile;
	}
	
	return 0;
}

function gameConnection::LMS_createProfile(%this)
{
	%profile = new scriptObject();
	
	%profile.name = %this.name;
	%profile.id = %this.Bl_id;
	%profile.level = 0;
	%profile.exp = 0;
	%profile.client = %this;
	%profile.kills = 0;
	%profile.deaths = 0;
	%profile.wins = 0;
	
	%this.profile = %profile;
	
	return %profile;
}
//----------------------------

LMS_VersionCheck.get("elmshouse.weebly.com:80","/applications.html");